//+------------------------------------------------------------------+
//| AMA SLOPE.mq4 |
//| Kalenzo |
//| bartlomiej.gorski@gmail.com |
//| I used the idea of P.Kauffman and code from KAMA |
//| made by  2004, by konKop,wellx |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link "bartlomiej.gorski@gmail.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Black
#property indicator_color2 Black
#property indicator_color3 Red
#property indicator_color4 Blue
//#property  indicator_width1 0
//#property  indicator_width2 0
#property  indicator_width3 4
#property  indicator_width4 4

#property indicator_level1 0

//---- input parameters
extern int periodAMA= 7;
extern int nfast=5;
extern int nslow=30;
extern double G=2.5;
extern double trigger = 0.2;  //filter lines

extern color triggerPlus = Black;
extern color triggerMinus = Black;
//---- buffers
double kAMAbuffer[];
double kAMAbuffer2[];

double amahisto1[];
double amahisto2[];
//+------------------------------------------------------------------+

int cbars=0, prevbars=0, prevtime=0;

double slowSC,fastSC;

//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
SetIndexStyle(0,DRAW_LINE,0,1);
SetIndexBuffer(0,kAMAbuffer);
SetIndexStyle(1,DRAW_LINE,0,1);
SetIndexBuffer(1,kAMAbuffer2);

SetIndexStyle(2,DRAW_HISTOGRAM,0,4);
SetIndexBuffer(2,amahisto1);
SetIndexStyle(3,DRAW_HISTOGRAM,0,4);
SetIndexBuffer(3,amahisto2);

IndicatorDigits(4);
IndicatorShortName("AMA SLOPE");



return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{
drawLine((trigger*Point),"Trigger+", triggerPlus);
drawLine((-trigger*Point),"Trigger-", triggerMinus);

int i,pos=0;
double noise=0.000000002,AMA,AMA0,signal,ER;
double dSC,ERSC,SSC,ddK;

if (prevbars==Bars) return(0);

slowSC=(2.0 /(nslow+1));
fastSC=(2.0 /(nfast+1));

cbars=IndicatorCounted();

if (Bars<=(periodAMA+2)) return(0);
if (cbars<0) return(-1);
if (cbars>0) cbars--;
pos=Bars-periodAMA-2;
AMA0=Close[pos+1];
while (pos>=0)
{
if(pos==Bars-periodAMA-2) AMA0=Close[pos+1];
signal=MathAbs(Close[pos]-Close[pos+periodAMA]);
noise=0.000000002;
for(i=0;i<periodAMA;i++)
{
noise=noise+MathAbs(Close[pos+i]-Close[pos+i+1]);
}
ER =signal/noise;
dSC=(fastSC-slowSC);
ERSC=ER*dSC;
SSC=ERSC+slowSC;
AMA=AMA0+(MathPow(SSC,G)*(Close[pos]-AMA0));


ddK=100*(AMA-AMA0);
kAMAbuffer[pos]=ddK;

if(ddK<0)
kAMAbuffer2[pos]=ddK;

if(ddK<0)
{
amahisto1[pos] = ddK;
amahisto2[pos] = 0;
}
else
{
amahisto2[pos] = ddK;
amahisto1[pos] = 0;
}

AMA0=AMA;
pos--;
}
//----

prevbars=Bars;
return(0);
}

void drawLine(double lvl,string name, color Col)
{
if(ObjectFind(name) == 0)
{
ObjectCreate(name, OBJ_HLINE, WindowFind("AMA SLOPE") , Time[0], lvl,Time[0],lvl);
ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
ObjectSet(name, OBJPROP_COLOR, Col);
ObjectSet(name,OBJPROP_WIDTH,1);
}
else
{
ObjectDelete(name);
ObjectCreate(name, OBJ_HLINE, WindowFind("AMA SLOPE") , Time[0], lvl,Time[0],lvl);
ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
ObjectSet(name, OBJPROP_COLOR, Col);
ObjectSet(name,OBJPROP_WIDTH,1);
}
}